Merge pull request #733 from sideeffect42/refactor-openbsd-pkg-type

Refactor __package_pkg_openbsd type
This commit is contained in:
Darko Poljak 2018-12-19 17:13:10 +01:00 committed by GitHub
commit 585221db28
No known key found for this signature in database
GPG Key ID: 4AEE18F83AFDEB23
3 changed files with 135 additions and 88 deletions

View File

@ -0,0 +1,49 @@
#!/bin/sh
#
# Copyright 2018, Takashi Yoshi <takashi@yoshi.email>
#
# This file is part of cdist.
#
# cdist is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# cdist is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with cdist. If not, see <http://www.gnu.org/licenses/>.
#
#
# Retrieve the status of a package - parsed pkg_info output
#
if [ -f "${__object}/parameter/name" ]
then
pkgid="$(cat "${__object}/parameter/name")"
else
pkgid="${__object_id}"
fi
if [ -f "${__object}/parameter/version" ]
then
pkgid="${pkgid}-$(cat "${__object}/parameter/version")"
fi
if [ -f "${__object}/parameter/flavor" ]
then
# If a flavor but no version is given we need to add another -,
# otherwise pkg_info confuses the flavor with the version.
[ -f "${__object}/parameter/version" ] || pkgid="${pkgid}-"
pkgid="${pkgid}-$(cat "${__object}/parameter/flavor")"
fi
pkg_info -q -I "inst:${pkgid}" >/dev/null 2>&1 \
&& echo 'present' || echo 'absent'
exit 0

View File

@ -2,6 +2,7 @@
# #
# 2011 Andi Brönnimann (andi-cdist at v-net.ch) # 2011 Andi Brönnimann (andi-cdist at v-net.ch)
# Copyright 2017, Philippe Gregoire <pg@pgregoire.xyz> # Copyright 2017, Philippe Gregoire <pg@pgregoire.xyz>
# Copyright 2018, Takashi Yoshi <takashi@yoshi.email>
# #
# This file is part of cdist. # This file is part of cdist.
# #
@ -19,7 +20,7 @@
# along with cdist. If not, see <http://www.gnu.org/licenses/>. # along with cdist. If not, see <http://www.gnu.org/licenses/>.
# #
# #
# Retrieve the status of a package - parsed dpkg output # Retrieve the version of a package - parsed pkg_info output
# #
if [ -f "$__object/parameter/name" ]; then if [ -f "$__object/parameter/name" ]; then
@ -28,5 +29,10 @@ else
name="$__object_id" name="$__object_id"
fi fi
#TODO: Is there a better way? # Extract version number from pkg_info.
pkg_info | grep "^$name-[0-9]" | sed 's|.*\(-[0-9][0-9.]*\).*|\1|' | sed 's/-//' # Refer to packages-specs(7) for more information regarding the format.
# ATTENTION: If $name is just a stem (e.g. "php" or "python"), there may be
# multiple results. pkg_info prints a line for each version.
pkg_info -q -I "inst:$name" | sed -e 's/^\([^-]*-\)*\([0-9][^-]*\).*$/\2/'

View File

@ -2,6 +2,7 @@
# #
# 2011 Andi Brönnimann (andi-cdist at v-net.ch) # 2011 Andi Brönnimann (andi-cdist at v-net.ch)
# 2012 Nico Schottelius (nico-cdist at schottelius.org) # 2012 Nico Schottelius (nico-cdist at schottelius.org)
# 2018 Takashi Yoshi <takashi@yoshi.email>
# #
# This file is part of cdist. # This file is part of cdist.
# #
@ -22,107 +23,98 @@
# Manage packages with pkg on OpenBSD # Manage packages with pkg on OpenBSD
# #
# Debug os_version=$(cat "${__global}/explorer/os_version")
# exec >&2 machine=$(cat "${__global}/explorer/machine")
# set -x
os_version="$(cat "$__global/explorer/os_version")" if [ -f "${__object}/parameter/version" ]; then
machine="$(cat "$__global/explorer/machine")" version=$(cat "${__object}/parameter/version")
if [ -f "$__object/parameter/version" ]; then
version="$(cat "$__object/parameter/version")"
fi fi
if [ -f "$__object/parameter/flavor" ]; then if [ -f "${__object}/parameter/flavor" ]; then
flavor="$(cat "$__object/parameter/flavor")" flavor=$(cat "${__object}/parameter/flavor")
fi fi
# do not show progress bar # Do not show progress bar
pkgopts="-x" pkgopts='-x'
if [ -f "$__object/parameter/name" ]; then name="${__object_id}"
name=$(cat "$__object/parameter/name") if [ -f "${__object}/parameter/name" ]; then
name=$(cat "${__object}/parameter/name")
fi
if [ -n "${version}" ] && [ -n "${flavor}" ]; then
pkgid="${name}-${version}-${flavor}"
elif [ -n "${version}" ]; then
pkgid="${name}-${version}"
elif [ -f "${__object}/parameter/flavor" ]; then
pkgid="${name}--${flavor}"
else else
name="$__object_id" pkgid="${name}"
fi fi
if [ -n "$version" ] && [ -n "$flavor" ]; then state_should=$(cat "${__object}/parameter/state")
pkgid="$name-$version-$flavor"
elif [ -n "$version" ]; then pkg_version=$(cat "${__object}/explorer/pkg_version")
pkgid="$name-$version"
elif [ -n "$flavor" ]; then if [ -f "${__object}/parameter/pkg_path" ]; then
pkgid="$name--$flavor" pkg_path=$(cat "${__object}/parameter/pkg_path")
elif [ -f "$__object/parameter/flavor" ]; then
pkgid="$name--"
else else
pkgid="$name" has_installurl=$(cat "${__object}/explorer/has_installurl")
if [ 'yes' != "${has_installurl}" ]; then
# There is no default PKG_PATH, try to provide one
pkg_path="ftp://ftp.openbsd.org/pub/OpenBSD/${os_version}/packages/${machine}/"
fi
fi fi
state_should="$(cat "$__object/parameter/state")" state_is=$(cat "${__object}/explorer/pkg_state")
[ "${state_is}" = "${state_should}" ] && exit 0
pkg_version="$(cat "$__object/explorer/pkg_version")" case "${state_should}" in
present)
if [ -n "${pkg_path}" ]; then
echo "export PKG_PATH='${pkg_path}'"
fi
if [ -f "$__object/parameter/pkg_path" ]; then # Use this because pkg_add doesn't properly handle errors
pkg_path="$(cat "$__object/parameter/pkg_path")" cat <<EOF
else status=\$(pkg_add ${pkgopts} '${pkgid}' 2>&1 || true)
has_installurl=$(cat "${__object}/explorer/has_installurl")
if [ Xyes != X"${has_installurl}" ]; then if ! pkg_info -q -I 'inst:${pkgid}' | grep -q '^${name}-${version}.*${flavor}$' 2>/dev/null
# there is no default PKG_PATH, try to provide one then
pkg_path="ftp://ftp.openbsd.org/pub/OpenBSD/$os_version/packages/$machine/" # We didn't find the package in the list of 'installed packages', so it failed.
fi # This is necessary because pkg_add doesn't return properly
if [ -z "\${status}" ]; then
status='Failed to add package, uncaught exception.'
fi
echo "Error: \${status}" >&2
exit 1
fi fi
EOF
echo 'installed' >> "${__messages_out}"
;;
if [ "$pkg_version" ]; then absent)
state_is="present" # Use this because pkg_delete doesn't properly handle errors
else cat <<EOF
state_is="absent" status=\$(pkg_delete ${pkgopts} '${pkgid}' 2>&1 || true)
if pkg_info -q -I 'inst:${pkgid}' | grep -q '^${name}-${version}.*${flavor}' 2>/dev/null
then
# We found the package in the list of 'installed packages'.
# This would indicate that pkg_delete failed, send the output of pkg_delete
if [ -z "\${status}" ]; then
status='Failed to remove package, uncaught exception.'
fi
echo "Error: \${status}" >&2
exit 1
fi fi
EOF
[ "$state_is" = "$state_should" ] && exit 0 echo 'removed' >> "${__messages_out}"
;;
case "$state_should" in *)
present) echo "Unknown state: ${state_should}" >&2
# use this because pkg_add doesn't properly handle errors
cat << eof
if [ X != X"${pkg_path}" ]; then
PKG_PATH="${pkg_path}"; export PKG_PATH
fi
status=\$(pkg_add "$pkgopts" "$pkgid" 2>&1)
pkg_info | grep "^${name}.*${version}.*${flavor}" > /dev/null 2>&1
# We didn't find the package in the list of 'installed packages', so it failed
# This is necessary because pkg_add doesn't return properly
if [ \$? -ne 0 ]; then
if [ -z "\${status}" ]; then
status="Failed to add package, uncaught exception."
fi
echo "Error: \$status"
exit 1
fi
eof
echo "installed" >> "$__messages_out"
;;
absent)
# use this because pkg_delete doesn't properly handle errors
cat << eof
status=\$(pkg_delete "$pkgopts" "$pkgid")
pkg_info | grep "^${name}.*${version}.*${flavor}" > /dev/null 2>&1
# We found the package in the list of 'installed packages'
# This would indicate that pkg_delete failed, send the output of pkg_delete
if [ \$? -eq 0 ]; then
if [ -z "\${status}" ]; then
status="Failed to remove package, uncaught exception."
fi
echo "Error: \$status"
exit 1
fi
eof
echo "removed" >> "$__messages_out"
;;
*)
echo "Unknown state: $state_should" >&2
exit 1 exit 1
;; ;;
esac esac